module pcf8591_iic_drive(
	sys_clk,
	rst_n,
	start_en,
	SCL,
	iic_busy,
	data_receive,
	SDA);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	input start_en;
	output SCL;
	output iic_busy;
	output [7:0] data_receive;
	inout SDA;

	wire sys_clk;
	wire rst_n;
	wire start_en;
	reg SCL;
	reg iic_busy;
	reg [7:0] data_receive;
	wire SDA;

	//----Code starts here: integrated by Robei-----
	parameter IDLE=4'd0;            //ʱ
	parameter START=4'd1;           //IICʼ
	parameter S_ADD=4'd2;           //ӻַд+ 0д1
	parameter S_ACK_ONE=4'd3;       //дӻַ󣬴ӻӦ
	parameter W_CMD=4'd4;           //д롰ģΪADģʽѡAINO23ͨ
	parameter S_ACK_TWO=4'd5;       //д󣬴ӻӦ
	parameter STOP=4'd6;            //iicֹͣ
	parameter DELAY=4'd7;           //дɣIICֹͣӳһʱ䣬ʼ
	parameter R_DATA=4'd8;          //ȡIICӻ
	parameter M_NACK=4'd9;          //Ӧ
	parameter FINISH=4'd10;         //дɣӳɺ 
	  
	//ʱӷƵ
	localparam Mid_High=83,
	           Neg_SCL=167,
	           Mid_Low=250,
	           Pos_SCL=334,
	           CNT_STOP=150;
	//reg [7:0] data_receive;    //iicյ
	reg [9:0] cnt_sys_clk;     //ʱӷƵ
	wire mid_high;
	wire neg_scl;
	wire mid_low;
	wire pos_scl;
	wire stop_flag;
	assign   mid_high=(cnt_sys_clk== Mid_High) ;     //SCLĸߵƽмʱ̣SDAֵɸͣʾʼSDAֵɵߣʾ
	assign   neg_scl= (cnt_sys_clk==Neg_SCL)    ;
	assign   mid_low= (cnt_sys_clk==Mid_Low)    ;    //SCLĵ͵ƽмʱ̣ڴݵݵĸı䣨ڸʱ̸ıݣ
	assign   pos_scl= (cnt_sys_clk==Pos_SCL)    ;  
	assign   stop_flag=(cnt_sys_clk==CNT_STOP) ;
	
	wire [7:0] add_write;
	wire [7:0] add_read;
	wire [7:0] cmd;
	assign add_write=8'b1001_0010;
	assign add_read=8'b1001_0011;
	assign cmd=8'b0100_0010;
	
	reg sda_out;
	wire sda_in;
	reg oe;
	wire oe_sim;                   //ڷ
	assign SDA=oe?sda_out:1'hz;
	assign sda_in=SDA;
	assign oe_sim=oe;
	
	//SCL
	reg SCL_en;
	always@(posedge sys_clk or negedge rst_n)begin
	    if(!rst_n)
	        cnt_sys_clk<=10'b00_0000_0000;
	    else if(SCL_en)
	        if(cnt_sys_clk==Pos_SCL)
	            cnt_sys_clk<=10'b00_0000_0000;
	        else
	            cnt_sys_clk<=cnt_sys_clk+1;
	    else
	        cnt_sys_clk<=10'b00_0000_0000;
	end
	always @(posedge sys_clk or negedge rst_n)begin
	    if(!rst_n)
	       SCL<=1'b1;
	   else if(SCL_en)
	       if(neg_scl) 
	           SCL<=1'b0;
	       else if(pos_scl)
	           SCL<=1'b1;
	       else
	           SCL<=SCL;
	   else
	       SCL<=1'b1;
	end
	
	//state
	reg [3:0] cnt_data;              //ڼ¼һֽеĵڼλ  "" word_out_reg[7-cnt_data]: cnt_data: 0~8 ;Ϊ8ʱsda_out<=sda_out;
	//reg [3:0] cnt_byte;              //ڼ¼˵ڼֽ;           cnt_data==8:  cnt_byte=cnt_byte+1;    
	(* mark_debug=1 *)reg [3:0] state;
	reg [3:0] next_state;
	reg sack_flag;                   //ڱǴӻǷӦ      ء      
	parameter CNT_DELAY=33_3333;
	reg [7:0] word_out_reg;         //IIC    ء
	reg [7:0] word_in_reg;          //IIC     ء
	reg finish_delay;               //ڱӳ          ""
	reg [19:0] cnt_delay;       //""
	reg [1:0] cnt_d_time;     //ڼ¼ӳٵĴ     0  1  2    ""
	wire state_sim;           //ڷ
	assign state_sim=state;
	always @(posedge sys_clk or negedge rst_n)begin
	    if(!rst_n)
	        state<=3'b000;
	    else
	        state<=next_state;
	end
	//״̬ת
	always@(*)begin
	    if(!rst_n)
	        next_state=3'b000;
	    else
	        case(state)
	                IDLE:begin
	                    if(start_en)
	                        next_state=START;
	                    else
	                        next_state=IDLE;
	                end
	                START:begin
	                    if(mid_low)
	                        next_state=S_ADD;
	                    else
	                        next_state=START;
	                end
	                S_ADD:begin
	                    if(cnt_data==4'd8&&pos_scl)
	                        next_state=S_ACK_ONE;
	                    else
	                        next_state=S_ADD;
	                end
	                S_ACK_ONE:begin                
	                    case({mid_low,sack_flag,finish_delay})
	                        3'b110:begin                    //"д"  дӻַӦ
	                            next_state=W_CMD;
	                        end
	                        3'b111:begin                   //̡дӻַӦ
	                            next_state=R_DATA;
	                        end
	                        3'b100:begin                   //"д"  дӻַӦ
	                            next_state=STOP;
	                        end
	                        3'b101:begin                  //̡дӻַӦ
	                            next_state=STOP;
	                        end
	                        default: next_state=S_ACK_ONE;     
	                    endcase
	                end
	                W_CMD:begin
	                    if(cnt_data==4'd8&&pos_scl)
	                        next_state=S_ACK_TWO;
	                    else
	                        next_state=W_CMD;
	                end
	                S_ACK_TWO:begin
	                    if(mid_low)
	                        next_state=STOP;
	                    else
	                        next_state=S_ACK_TWO;                          
	                end
	                STOP:begin
	                    if(stop_flag)
	                        next_state=DELAY;
	                    else
	                        next_state=STOP;
	                end
	                DELAY:begin
	                if(cnt_delay==CNT_DELAY)begin
	                    if(cnt_d_time==2'd1)   //ӳٽ  cnt_d_time+1
	                        next_state= START;
	                    else 
	                        next_state= FINISH;
	                 end
	                 else
	                      next_state=DELAY;
	                end
	                R_DATA:begin
	                    if(cnt_data==4'd8)
	                          next_state=M_NACK;
	                      else
	                          next_state=R_DATA;
	                end
	                M_NACK: begin
	                    if(mid_low)
	                              next_state= STOP;
	                         else 
	                              next_state= M_NACK;
	                end
	                FINISH:begin
	                        next_state=IDLE;
	                end
	                default:    next_state=IDLE;
	            endcase                               
	end
	
	//data
	always @(posedge sys_clk or negedge rst_n)begin
	    if(!rst_n)begin
	        iic_busy<=1'b0;
	        cnt_data<=4'b0000;
	        SCL_en<=1'b0;
	        word_out_reg<=8'b0000_0000;
	        word_in_reg<=8'b0000_0000;
	        sda_out<=1'b1;
	        oe<=1'b0;
	        sack_flag<=1'b0;
	        finish_delay<=1'b0;
	        cnt_d_time<=2'd0;
	        cnt_delay<=16'd0;
	    end    
	    else
	        case(state)
	            IDLE:begin
	                iic_busy<=1'b0;
	                cnt_data<=4'b0000;
	                SCL_en<=1'b0;
	                word_out_reg<=8'b0000_0000;
	                word_in_reg<=8'b0000_0000;
	                sda_out<=1'b1;
	                oe<=1'b0;
	                sack_flag<=1'b0;
	                finish_delay<=1'b0;         //־һӳ
	                cnt_d_time<=2'd0;
	                cnt_delay<=16'd0;
	                word_out_reg<=add_write;   //״Ҫ
	            end
	            START:begin
	                oe<=1'b1;
	                SCL_en<=1'b1;
	                iic_busy<=1'b1;
	                if(mid_high)
	                    sda_out<=1'b0;
	            end  
	            S_ADD:begin               //дӻַ+д
	                sack_flag<=1'b0;
	                oe<=1'b1;
	                if(cnt_data<8)
	                    sda_out<=word_out_reg[7-cnt_data];
	                else begin
	                    sda_out<=sda_out;
	                end
	                if(mid_low)
	                    cnt_data<=cnt_data+1;   
	                else
	                    cnt_data<=cnt_data;
	            end
	            S_ACK_ONE:begin                // ӻַӦ׼
	                oe<=1'b0;
	                cnt_data<=4'b0000;
	                word_out_reg<=cmd;
	                if(mid_high)
	                    sack_flag<=~sda_in;                   
	            end
	             W_CMD:begin
	                sack_flag<=1'b0;
	                oe<=1'b1;
	                if(cnt_data<8)
	                    sda_out<=word_out_reg[7-cnt_data];
	                else begin
	                    sda_out<=sda_out;
	                end
	                if(mid_low)
	                    cnt_data<=cnt_data+1;   
	                else
	                    cnt_data<=cnt_data;
	             end
	             S_ACK_TWO:begin
	                oe<=1'b0;
	                cnt_data<=4'b0000;
	                word_out_reg<=8'b0000_0000;
	                if(mid_high)
	                    sack_flag<=~sda_in;      
	                if(mid_low)
	                    sda_out<=1'b0;          //Ϊֹͣ׼             
	             end
	            STOP:begin
	                oe<=1'b1;
	                if(mid_high)
	                    sda_out<=1'b1;
	                if(stop_flag)
	                    SCL_en<=1'b0;
	            end
	            DELAY:begin    
	                oe<=1'b0; 
	                word_out_reg<=add_read;      //"ӻ"д׼ 
	                   if(cnt_delay<CNT_DELAY)begin
	                       cnt_delay<=cnt_delay+1;
	                       finish_delay<=finish_delay;
	                   end
	                   else begin
	                       cnt_delay<=16'd0;
	                       finish_delay<=1'b1;
	                   end
	                   if(cnt_delay==CNT_DELAY-3)
	                       cnt_d_time<=cnt_d_time+1;
	                   else
	                       cnt_d_time<=cnt_d_time;
	            end
	            
	            R_DATA:begin                //SCL ߵƽмʱ̣IICݣ 8
	                  oe<=1'b0;
	                  if(mid_high)
	                      word_in_reg[7-cnt_data]<=sda_in;
	                  if(mid_low)
	                      cnt_data<=cnt_data+1;                           
	            end
	            M_NACK: begin   // ҪΪֹͣ׼    mid_low+2~mid_low
	                 oe<=1'b1;
	                 cnt_data<=4'b0000;
	                 if(pos_scl)
	                     sda_out<=1'b1;
	                 else if(mid_low)
	                     sda_out<=1'b0;
	                 else
	                     sda_out<=sda_out;
	            end
	            FINISH:begin          //ӳ5SCLʱڣiic_finish     
	                   data_receive<=  word_in_reg;
	                   word_out_reg<=8'b0000_0000;                              
	            end         
	            default:    ;
	        endcase
	end
	
	
	
endmodule    //pcf8591_iic_drive

